=== debian/changelog ===
ovito (3.10.5~ds-2) experimental; urgency=medium

  * Team upload.
  * configure build with -DOVITO_BUILD_DOCUMENTATION_STRICT=OFF
    to prevent doc build warnings making the whole build fail.
    Closes: #1071132
  * remove redundant debian/source/lintian-overrides (tests dir
    is no longer provided in source)

 -- Drew Parsons <dparsons@debian.org>  Tue, 27 May 2025 20:42:07 +0200

ovito (3.10.5~ds-1) experimental; urgency=medium

  * Update debian/watch
  * New upstream version 3.10.5~ds
  * Refresh patches

 -- Yadd <yadd@debian.org>  Mon, 22 Apr 2024 08:39:48 +0400
