=== debian/control ===
Source: ovito
Section: science
Priority: optional
Maintainer: Debian Pan Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders: Yadd <yadd@debian.org>
Build-Depends: debhelper-compat (= 13)
 , cmake
 , cmake-curses-gui
 , gemmi
 , gemmi-dev
 , libavcodec-dev
 , libavdevice-dev
 , libavfilter-dev
 , libavformat-dev
 , libavutil-dev
 , libboost-dev
 , libglu1-mesa-dev
 , libhdf5-dev
 , libhdf5-serial-dev
 , libkissfft-dev
 , libmuparser-dev
 , libnetcdf-dev
 , libqt6svg6-dev
 , libqwt-qt6-dev
 , libssh-dev
 , libswscale-dev
 , libvulkan-dev
 , ninja-build
 , qt6-base-dev
 , python3-sphinx-rtd-theme
 , sphinx
 , tao-pegtl-dev
 , voro++-dev
Standards-Version: 4.6.2
Homepage: https://www.ovito.org
Vcs-Browser: https://salsa.debian.org/debian/ovito
Vcs-Git: https://salsa.debian.org/debian/ovito.git
Rules-Requires-Root: no

Package: ovito
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}
 , ${shlibs:Depends}
Suggests: ovito-doc (= ${binary:Version})
Description: Scientific data visualization and analysis software for atomistic and molecular
 OVITO is a scientific data visualization and analysis software for atomistic,
 molecular and other particle-based simulations.

Package: ovito-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: ovito
Description: Documentation for ovito
 OVITO is a scientific data visualization and analysis software for atomistic,
 molecular and other particle-based simulations.
 .
 This package provides HTML documentation
