=== debian/tests/control ===
Test-Command: ovito --nogui
Depends: @
Features: test-name=nogui
